﻿using System.ComponentModel;
using System.Windows.Input;

namespace Kolory.ModelWidoku
{
    using Kolory.Model;

    public class StanMW : INotifyPropertyChanged
    {
        private Model.Stan stan = Model.DAL.CzytajZPlikuXml();

        public byte R
        {
            get
            {
                return stan.R;
            }
            set
            {
                //TODO: do zmiany na event-to-command                
                //stan.ZapiszDoPlikuXml();
                stan.R = value;
                onPropertyChanged(nameof(R)/*, nameof(Pędzel)*/);
            }
        }

        public byte G
        {
            get
            {
                return stan.G;
            }
            set
            {
                //stan.ZapiszDoPlikuXml();
                stan.G = value;
                onPropertyChanged(nameof(G)/*, nameof(Pędzel)*/);
            }
        }

        public byte B
        {
            get
            {
                return stan.B;
            }
            set
            {
                //stan.ZapiszDoPlikuXml();
                stan.B = value;
                onPropertyChanged(nameof(B)/*, nameof(Pędzel)*/);
            }
        }

        /*
        public Brush Pędzel //TODO: nie powinniśmy korzystać z typów UI w VM
        {
            get
            {
                Color kolor = Color.FromRgb(R, G, B);
                return new SolidColorBrush(kolor); //TODO: wyciek pamięci?
            }
        }
        */

        public event PropertyChangedEventHandler? PropertyChanged;

        private void onPropertyChanged(params string?[] nazwyWłasności)
        {
            if (PropertyChanged != null)
            {
                foreach(string? nazwaWłasności in nazwyWłasności)
                    PropertyChanged(this, new PropertyChangedEventArgs(nazwaWłasności));
            }
        }

        private ICommand resetuj = null;

        public ICommand Resetuj
        {
            get
            {
                if (resetuj == null)
                {
                    Action resetowanie = () => { R = 0; G = 0; B = 0; };
                    resetuj = new Command(resetowanie);
                }
                return resetuj;
            }
        }

        private ICommand zapisz = null;

        public ICommand Zapisz
        {
            get
            {
                if (zapisz == null) zapisz = new Command(
                    (object p) => { stan.ZapiszDoPlikuXml(); });
                return zapisz;
            }
        }
    }
}
